Index: palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model_mod.f90	(revision 2693)
+++ palm/trunk/SOURCE/radiation_model_mod.f90	(revision 2696)
@@ -1036,29 +1642,417 @@
 #if defined ( __rrtmg )
 !
-!--       Allocate albedos
-          ALLOCATE ( rrtm_aldif(0:0,nysg:nyng,nxlg:nxrg) )
-          ALLOCATE ( rrtm_aldir(0:0,nysg:nyng,nxlg:nxrg) )
-          ALLOCATE ( rrtm_asdif(0:0,nysg:nyng,nxlg:nxrg) )
-          ALLOCATE ( rrtm_asdir(0:0,nysg:nyng,nxlg:nxrg) )
-          ALLOCATE ( aldif(nysg:nyng,nxlg:nxrg) )
-          ALLOCATE ( aldir(nysg:nyng,nxlg:nxrg) )
-          ALLOCATE ( asdif(nysg:nyng,nxlg:nxrg) )
-          ALLOCATE ( asdir(nysg:nyng,nxlg:nxrg) )
-
-          IF ( albedo_type /= 0 )  THEN
-             IF ( albedo_sw_dif == 9999999.9_wp )  THEN
-                albedo_sw_dif = albedo_pars(0,albedo_type)
-                albedo_sw_dir = albedo_sw_dif
+!--       Allocate albedos for short/longwave radiation, horizontal surfaces.
+          ALLOCATE ( surf_def_h(0)%aldif(1:surf_def_h(0)%ns) )
+          ALLOCATE ( surf_def_h(0)%aldir(1:surf_def_h(0)%ns) )
+          ALLOCATE ( surf_def_h(0)%asdif(1:surf_def_h(0)%ns) )
+          ALLOCATE ( surf_def_h(0)%asdir(1:surf_def_h(0)%ns) )
+          ALLOCATE ( surf_def_h(0)%rrtm_aldif(1:surf_def_h(0)%ns) )
+          ALLOCATE ( surf_def_h(0)%rrtm_aldir(1:surf_def_h(0)%ns) )
+          ALLOCATE ( surf_def_h(0)%rrtm_asdif(1:surf_def_h(0)%ns) )
+          ALLOCATE ( surf_def_h(0)%rrtm_asdir(1:surf_def_h(0)%ns) )
+
+          ALLOCATE ( surf_lsm_h%aldif(1:surf_lsm_h%ns)       )
+          ALLOCATE ( surf_lsm_h%aldir(1:surf_lsm_h%ns)       )
+          ALLOCATE ( surf_lsm_h%asdif(1:surf_lsm_h%ns)       )
+          ALLOCATE ( surf_lsm_h%asdir(1:surf_lsm_h%ns)       )
+          ALLOCATE ( surf_lsm_h%rrtm_aldif(1:surf_lsm_h%ns)  )
+          ALLOCATE ( surf_lsm_h%rrtm_aldir(1:surf_lsm_h%ns)  )
+          ALLOCATE ( surf_lsm_h%rrtm_asdif(1:surf_lsm_h%ns)  )
+          ALLOCATE ( surf_lsm_h%rrtm_asdir(1:surf_lsm_h%ns)  )
+
+          ALLOCATE ( surf_usm_h%aldif(1:surf_usm_h%ns)       )
+          ALLOCATE ( surf_usm_h%aldir(1:surf_usm_h%ns)       )
+          ALLOCATE ( surf_usm_h%asdif(1:surf_usm_h%ns)       )
+          ALLOCATE ( surf_usm_h%asdir(1:surf_usm_h%ns)       )
+          ALLOCATE ( surf_usm_h%rrtm_aldif(1:surf_usm_h%ns)  )
+          ALLOCATE ( surf_usm_h%rrtm_aldir(1:surf_usm_h%ns)  )
+          ALLOCATE ( surf_usm_h%rrtm_asdif(1:surf_usm_h%ns)  )
+          ALLOCATE ( surf_usm_h%rrtm_asdir(1:surf_usm_h%ns)  )
+
+!
+!--       Allocate broadband albedo (temporary for the current radiation 
+!--       implementations)
+          IF ( .NOT. ALLOCATED(surf_def_h(0)%albedo) )                         &
+             ALLOCATE( surf_def_h(0)%albedo(0:0,1:surf_def_h(0)%ns) )
+          IF ( .NOT. ALLOCATED(surf_lsm_h%albedo) )                            &
+             ALLOCATE( surf_lsm_h%albedo(0:2,1:surf_lsm_h%ns)     )
+          IF ( .NOT. ALLOCATED(surf_usm_h%albedo) )                            &
+             ALLOCATE( surf_usm_h%albedo(0:2,1:surf_usm_h%ns)     )
+
+!
+!--       Allocate albedos for short/longwave radiation, vertical surfaces 
+          DO  l = 0, 3
+             ALLOCATE ( surf_def_v(l)%aldif(1:surf_def_v(l)%ns)      )
+             ALLOCATE ( surf_def_v(l)%aldir(1:surf_def_v(l)%ns)      )
+             ALLOCATE ( surf_def_v(l)%asdif(1:surf_def_v(l)%ns)      )
+             ALLOCATE ( surf_def_v(l)%asdir(1:surf_def_v(l)%ns)      )
+
+             ALLOCATE ( surf_def_v(l)%rrtm_aldif(1:surf_def_v(l)%ns) )
+             ALLOCATE ( surf_def_v(l)%rrtm_aldir(1:surf_def_v(l)%ns) )
+             ALLOCATE ( surf_def_v(l)%rrtm_asdif(1:surf_def_v(l)%ns) )
+             ALLOCATE ( surf_def_v(l)%rrtm_asdir(1:surf_def_v(l)%ns) )
+
+             ALLOCATE ( surf_lsm_v(l)%aldif(1:surf_lsm_v(l)%ns)      )
+             ALLOCATE ( surf_lsm_v(l)%aldir(1:surf_lsm_v(l)%ns)      )
+             ALLOCATE ( surf_lsm_v(l)%asdif(1:surf_lsm_v(l)%ns)      )
+             ALLOCATE ( surf_lsm_v(l)%asdir(1:surf_lsm_v(l)%ns)      )
+
+             ALLOCATE ( surf_lsm_v(l)%rrtm_aldif(1:surf_lsm_v(l)%ns) )
+             ALLOCATE ( surf_lsm_v(l)%rrtm_aldir(1:surf_lsm_v(l)%ns) )
+             ALLOCATE ( surf_lsm_v(l)%rrtm_asdif(1:surf_lsm_v(l)%ns) )
+             ALLOCATE ( surf_lsm_v(l)%rrtm_asdir(1:surf_lsm_v(l)%ns) )
+
+             ALLOCATE ( surf_usm_v(l)%aldif(1:surf_usm_v(l)%ns)      )
+             ALLOCATE ( surf_usm_v(l)%aldir(1:surf_usm_v(l)%ns)      )
+             ALLOCATE ( surf_usm_v(l)%asdif(1:surf_usm_v(l)%ns)      )
+             ALLOCATE ( surf_usm_v(l)%asdir(1:surf_usm_v(l)%ns)      )
+
+             ALLOCATE ( surf_usm_v(l)%rrtm_aldif(1:surf_usm_v(l)%ns) )
+             ALLOCATE ( surf_usm_v(l)%rrtm_aldir(1:surf_usm_v(l)%ns) )
+             ALLOCATE ( surf_usm_v(l)%rrtm_asdif(1:surf_usm_v(l)%ns) )
+             ALLOCATE ( surf_usm_v(l)%rrtm_asdir(1:surf_usm_v(l)%ns) )
+!
+!--          Allocate broadband albedo (temporary for the current radiation
+!--          implementations)
+             IF ( .NOT. ALLOCATED( surf_def_v(l)%albedo ) )                    &
+                ALLOCATE( surf_def_v(l)%albedo(0,1:surf_def_v(l)%ns) )
+             IF ( .NOT. ALLOCATED( surf_lsm_v(l)%albedo ) )                    &
+                ALLOCATE( surf_lsm_v(l)%albedo(0:2,1:surf_lsm_v(l)%ns) )
+             IF ( .NOT. ALLOCATED( surf_usm_v(l)%albedo ) )                    &
+                ALLOCATE( surf_usm_v(l)%albedo(0:2,1:surf_usm_v(l)%ns) )
+
+          ENDDO
+!
+!--       Level 1 initialization of spectral albedos via namelist 
+!--       paramters
+          IF ( surf_def_h(0)%ns > 0 )  THEN
+             surf_def_h(0)%aldif  = albedo_lw_dif
+             surf_def_h(0)%aldir  = albedo_lw_dir
+             surf_def_h(0)%asdif  = albedo_sw_dif
+             surf_def_h(0)%asdir  = albedo_sw_dir
+             surf_def_h(0)%albedo = albedo_sw_dif
+          ENDIF
+          IF ( surf_lsm_h%ns > 0 )  THEN
+             surf_lsm_h%aldif  = albedo_lw_dif
+             surf_lsm_h%aldir  = albedo_lw_dir
+             surf_lsm_h%asdif  = albedo_sw_dif
+             surf_lsm_h%asdir  = albedo_sw_dir
+             surf_lsm_h%albedo = albedo_sw_dif
+          ENDIF
+          IF ( surf_usm_h%ns > 0 )  THEN
+             surf_usm_h%aldif  = albedo_lw_dif
+             surf_usm_h%aldir  = albedo_lw_dir
+             surf_usm_h%asdif  = albedo_sw_dif
+             surf_usm_h%asdir  = albedo_sw_dir
+             surf_usm_h%albedo = albedo_sw_dif
+          ENDIF
+
+          DO  l = 0, 3
+             IF ( surf_def_v(l)%ns > 0 )  THEN
+                surf_def_v(l)%aldif  = albedo_lw_dif
+                surf_def_v(l)%aldir  = albedo_lw_dir
+                surf_def_v(l)%asdif  = albedo_sw_dif
+                surf_def_v(l)%asdir  = albedo_sw_dir
+                surf_def_v(l)%albedo = albedo_sw_dif
              ENDIF
-             IF ( albedo_lw_dif == 9999999.9_wp )  THEN
-                albedo_lw_dif = albedo_pars(1,albedo_type)
-                albedo_lw_dir = albedo_lw_dif
+
+             IF ( surf_lsm_v(l)%ns > 0 )  THEN
+                surf_lsm_v(l)%aldif  = albedo_lw_dif
+                surf_lsm_v(l)%aldir  = albedo_lw_dir
+                surf_lsm_v(l)%asdif  = albedo_sw_dif
+                surf_lsm_v(l)%asdir  = albedo_sw_dir
+                surf_lsm_v(l)%albedo = albedo_sw_dif
              ENDIF
+
+             IF ( surf_usm_v(l)%ns > 0 )  THEN
+                surf_usm_v(l)%aldif  = albedo_lw_dif
+                surf_usm_v(l)%aldir  = albedo_lw_dir
+                surf_usm_v(l)%asdif  = albedo_sw_dif
+                surf_usm_v(l)%asdir  = albedo_sw_dir
+                surf_usm_v(l)%albedo = albedo_sw_dif
+             ENDIF
+          ENDDO
+
+!
+!--       Level 2 initialization of spectral albedos via albedo_type. 
+!--       Only diffusive albedos (why?)
+          DO  m = 1, surf_def_h(0)%ns
+             IF ( surf_def_h(0)%albedo_type(0,m) /= 0 )  THEN
+                surf_def_h(0)%aldif(m) =                                       &
+                                albedo_pars(0,surf_def_h(0)%albedo_type(0,m))
+                surf_def_h(0)%asdif(m) =                                       &
+                                albedo_pars(1,surf_def_h(0)%albedo_type(0,m))
+                surf_def_h(0)%aldir(m) =                                       &
+                                albedo_pars(0,surf_def_h(0)%albedo_type(0,m))
+                surf_def_h(0)%asdir(m) =                                       &
+                                albedo_pars(1,surf_def_h(0)%albedo_type(0,m))
+                surf_def_h(0)%albedo(0,m) =                                    &
+                                albedo_pars(2,surf_def_h(0)%albedo_type(0,m))
+             ENDIF
+          ENDDO
+          DO  m = 1, surf_lsm_h%ns
+!
+!--          Determine surface type
+             IF ( surf_lsm_h%vegetation_surface(m) )  ind_type = 0
+             IF ( surf_lsm_h%pavement_surface(m)   )  ind_type = 1
+             IF ( surf_lsm_h%water_surface(m)      )  ind_type = 2
+
+             IF ( surf_lsm_h%albedo_type(ind_type,m) /= 0 )  THEN
+                surf_lsm_h%aldif(m) =                                          &
+                               albedo_pars(0,surf_lsm_h%albedo_type(ind_type,m))
+                surf_lsm_h%asdif(m) =                                          &
+                               albedo_pars(1,surf_lsm_h%albedo_type(ind_type,m))
+                surf_lsm_h%aldir(m) =                                          &
+                               albedo_pars(0,surf_lsm_h%albedo_type(ind_type,m))
+                surf_lsm_h%asdir(m) =                                          &
+                               albedo_pars(1,surf_lsm_h%albedo_type(ind_type,m))
+                surf_lsm_h%albedo(:,m) =                                       &
+                               albedo_pars(2,surf_lsm_h%albedo_type(ind_type,m))
+             ENDIF
+
+          ENDDO
+
+          DO  m = 1, surf_usm_h%ns
+!
+!--          Initialize spectral albedos for urban-type surfaces. Please note,
+!--          for urban surfaces a tile approach is applied, so that the 
+!--          resulting albedo should be calculated via the weighted average of  
+!--          respective surface fractions. However, for the moment the albedo
+!--          is set to the wall-surface value. 
+             IF ( surf_usm_h%albedo_type(0,m) /= 0 )  THEN
+                surf_usm_h%aldif(m) =                                          &
+                                albedo_pars(0,surf_usm_h%albedo_type(0,m))
+                surf_usm_h%asdif(m) =                                          &
+                                albedo_pars(1,surf_usm_h%albedo_type(0,m))
+                surf_usm_h%aldir(m) =                                          &
+                               albedo_pars(0,surf_usm_h%albedo_type(0,m))
+                surf_usm_h%asdir(m) =                                          &
+                               albedo_pars(1,surf_usm_h%albedo_type(0,m))
+                surf_usm_h%albedo(:,m) =                                       &
+                                albedo_pars(2,surf_usm_h%albedo_type(0,m))
+             ENDIF
+          ENDDO
+
+          DO l = 0, 3
+             DO  m = 1, surf_def_v(l)%ns
+                IF ( surf_def_v(l)%albedo_type(0,m) /= 0 )  THEN
+                    surf_def_v(l)%aldif(m) =                                   &
+                               albedo_pars(0,surf_def_v(l)%albedo_type(0,m))
+                    surf_def_v(l)%asdif(m) =                                   &
+                               albedo_pars(1,surf_def_v(l)%albedo_type(0,m))
+                    surf_def_v(l)%aldir(m) =                                   &
+                               albedo_pars(0,surf_def_v(l)%albedo_type(0,m))
+                    surf_def_v(l)%asdir(m) =                                   &
+                               albedo_pars(1,surf_def_v(l)%albedo_type(0,m))
+                    surf_def_v(l)%albedo(:,m) =                                &
+                               albedo_pars(2,surf_def_v(l)%albedo_type(0,m))
+                ENDIF
+             ENDDO
+             DO  m = 1, surf_lsm_v(l)%ns
+                IF ( surf_lsm_v(l)%vegetation_surface(m) )  ind_type = 0
+                IF ( surf_lsm_v(l)%pavement_surface(m)   )  ind_type = 1
+                IF ( surf_lsm_v(l)%water_surface(m)      )  ind_type = 2
+
+                IF ( surf_lsm_v(l)%albedo_type(0,m) /= 0 )  THEN
+                   surf_lsm_v(l)%aldif(m) =                                    &
+                            albedo_pars(0,surf_lsm_v(l)%albedo_type(ind_type,m))
+                   surf_lsm_v(l)%asdif(m) =                                    &
+                            albedo_pars(1,surf_lsm_v(l)%albedo_type(ind_type,m))
+                   surf_lsm_v(l)%aldir(m) =                                    &
+                            albedo_pars(0,surf_lsm_v(l)%albedo_type(ind_type,m))
+                   surf_lsm_v(l)%asdir(m) =                                    &
+                            albedo_pars(1,surf_lsm_v(l)%albedo_type(ind_type,m))
+                   surf_lsm_v(l)%albedo(:,m) =                                 &
+                            albedo_pars(2,surf_lsm_v(l)%albedo_type(ind_type,m))
+                ENDIF
+            ENDDO
+
+            DO  m = 1, surf_usm_v(l)%ns
+!
+!--            Initialize spectral albedos for urban-type surfaces. Please note,
+!--            for urban surfaces a tile approach is applied, so that the 
+!--            resulting albedo should be calculated via the weighted average of  
+!--            respective surface fractions. However, for the moment the albedo
+!--            is set to the wall-surface value. 
+               IF ( surf_usm_v(l)%albedo_type(0,m) /= 0 )  THEN
+                  surf_usm_v(l)%aldif(m) =                                    &
+                               albedo_pars(0,surf_usm_v(l)%albedo_type(0,m))
+                  surf_usm_v(l)%asdif(m) =                                    &
+                               albedo_pars(1,surf_usm_v(l)%albedo_type(0,m))
+                  surf_usm_v(l)%aldir(m) =                                    &
+                               albedo_pars(0,surf_usm_v(l)%albedo_type(0,m))
+                  surf_usm_v(l)%asdir(m) =                                    &
+                               albedo_pars(1,surf_usm_v(l)%albedo_type(0,m))
+                  surf_usm_v(l)%albedo(:,m) =                                 &
+                               albedo_pars(2,surf_usm_v(l)%albedo_type(0,m))
+               ENDIF
+            ENDDO
+          ENDDO
+!
+!--       Level 3 initialization at grid points where albedo type is zero.
+!--       This case, spectral albedos are taken from file if available
+          IF ( albedo_pars_f%from_file )  THEN
+!
+!--          Horizontal
+             DO  m = 1, surf_def_h(0)%ns
+                i = surf_def_h(0)%i(m)
+                j = surf_def_h(0)%j(m)
+                IF ( surf_def_h(0)%albedo_type(0,m) == 0 )  THEN
+
+                   IF ( albedo_pars_f%pars_xy(1,j,i) /= albedo_pars_f%fill )   &
+                      surf_def_h(0)%albedo(0,m) = albedo_pars_f%pars_xy(1,j,i)
+                   IF ( albedo_pars_f%pars_xy(1,j,i) /= albedo_pars_f%fill )   &
+                      surf_def_h(0)%aldir(m) = albedo_pars_f%pars_xy(1,j,i)
+                   IF ( albedo_pars_f%pars_xy(2,j,i) /= albedo_pars_f%fill )   &
+                      surf_def_h(0)%aldif(m) = albedo_pars_f%pars_xy(2,j,i)
+                   IF ( albedo_pars_f%pars_xy(3,j,i) /= albedo_pars_f%fill )   &
+                      surf_def_h(0)%asdir(m) = albedo_pars_f%pars_xy(3,j,i)
+                   IF ( albedo_pars_f%pars_xy(4,j,i) /= albedo_pars_f%fill )   &
+                      surf_def_h(0)%asdif(m) = albedo_pars_f%pars_xy(4,j,i)
+                ENDIF
+             ENDDO
+
+             DO  m = 1, surf_lsm_h%ns
+                i = surf_lsm_h%i(m)
+                j = surf_lsm_h%j(m)
+
+                IF ( surf_lsm_h%vegetation_surface(m) )  ind_type = 0
+                IF ( surf_lsm_h%pavement_surface(m)   )  ind_type = 1
+                IF ( surf_lsm_h%water_surface(m)      )  ind_type = 2
+
+                IF ( surf_lsm_h%albedo_type(ind_type,m) == 0 )  THEN
+                   IF ( albedo_pars_f%pars_xy(1,j,i) /= albedo_pars_f%fill )   &
+                      surf_lsm_h%albedo(ind_type,m) = albedo_pars_f%pars_xy(1,j,i)
+                   IF ( albedo_pars_f%pars_xy(1,j,i) /= albedo_pars_f%fill )   &
+                      surf_lsm_h%aldir(m) = albedo_pars_f%pars_xy(1,j,i)
+                   IF ( albedo_pars_f%pars_xy(2,j,i) /= albedo_pars_f%fill )   &
+                      surf_lsm_h%aldif(m) = albedo_pars_f%pars_xy(2,j,i)
+                   IF ( albedo_pars_f%pars_xy(3,j,i) /= albedo_pars_f%fill )   &
+                      surf_lsm_h%asdir(m) = albedo_pars_f%pars_xy(3,j,i)
+                   IF ( albedo_pars_f%pars_xy(4,j,i) /= albedo_pars_f%fill )   &
+                      surf_lsm_h%asdif(m) = albedo_pars_f%pars_xy(4,j,i)
+                ENDIF
+             ENDDO
+
+             DO  m = 1, surf_usm_h%ns
+                i = surf_usm_h%i(m)
+                j = surf_usm_h%j(m)
+!
+!--             At the moment, consider only wall surfaces (index 0)
+                IF ( surf_usm_h%albedo_type(0,m) == 0 )  THEN
+                   IF ( albedo_pars_f%pars_xy(1,j,i) /= albedo_pars_f%fill )   &
+                      surf_usm_h%albedo(:,m) = albedo_pars_f%pars_xy(1,j,i)
+                   IF ( albedo_pars_f%pars_xy(1,j,i) /= albedo_pars_f%fill )   &
+                      surf_usm_h%aldir(m) = albedo_pars_f%pars_xy(1,j,i)
+                   IF ( albedo_pars_f%pars_xy(2,j,i) /= albedo_pars_f%fill )   &
+                      surf_usm_h%aldif(m) = albedo_pars_f%pars_xy(2,j,i)
+                   IF ( albedo_pars_f%pars_xy(3,j,i) /= albedo_pars_f%fill )   &
+                      surf_usm_h%asdir(m) = albedo_pars_f%pars_xy(3,j,i)
+                   IF ( albedo_pars_f%pars_xy(4,j,i) /= albedo_pars_f%fill )   &
+                      surf_usm_h%asdif(m) = albedo_pars_f%pars_xy(4,j,i)
+                ENDIF
+             ENDDO
+!
+!--          Vertical
+             DO  l = 0, 3
+                ioff = surf_def_v(l)%ioff
+                joff = surf_def_v(l)%joff
+
+                DO  m = 1, surf_def_v(l)%ns
+                   i = surf_def_v(l)%i(m)
+                   j = surf_def_v(l)%j(m)
+                   IF ( surf_def_v(l)%albedo_type(0,m) == 0 )  THEN
+
+                      IF ( albedo_pars_f%pars_xy(1,j+joff,i+ioff) /=           &
+                           albedo_pars_f%fill )                                &
+                         surf_def_v(l)%albedo(0,m) =                           &
+                                          albedo_pars_f%pars_xy(1,j+joff,i+ioff)
+                      IF ( albedo_pars_f%pars_xy(1,j+joff,i+ioff) /=           &
+                           albedo_pars_f%fill )                                &
+                         surf_def_v(l)%aldir(m) =                              &
+                                          albedo_pars_f%pars_xy(1,j+joff,i+ioff)
+                      IF ( albedo_pars_f%pars_xy(2,j+joff,i+ioff) /=           &
+                           albedo_pars_f%fill )                                &
+                         surf_def_v(l)%aldif(m) =                              &
+                                          albedo_pars_f%pars_xy(2,j+joff,i+ioff)
+                      IF ( albedo_pars_f%pars_xy(3,j+joff,i+ioff) /=           &
+                           albedo_pars_f%fill )                                &
+                         surf_def_v(l)%asdir(m) =                              &
+                                          albedo_pars_f%pars_xy(3,j+joff,i+ioff)
+                      IF ( albedo_pars_f%pars_xy(4,j+joff,i+ioff) /=           &
+                           albedo_pars_f%fill )                                &
+                         surf_def_v(l)%asdif(m) =                              &
+                                          albedo_pars_f%pars_xy(4,j+joff,i+ioff)
+                   ENDIF
+                ENDDO
+
+                ioff = surf_lsm_v(l)%ioff
+                joff = surf_lsm_v(l)%joff
+                DO  m = 1, surf_lsm_v(l)%ns
+                   i = surf_lsm_v(l)%i(m)
+                   j = surf_lsm_v(l)%j(m)
+
+                   IF ( surf_lsm_v(l)%vegetation_surface(m) )  ind_type = 0
+                   IF ( surf_lsm_v(l)%pavement_surface(m)   )  ind_type = 1
+                   IF ( surf_lsm_v(l)%water_surface(m)      )  ind_type = 2
+
+                   IF ( surf_lsm_v(l)%albedo_type(ind_type,m) == 0 )  THEN
+                      IF ( albedo_pars_f%pars_xy(1,j+joff,i+ioff) /=           &
+                           albedo_pars_f%fill )                                &
+                         surf_lsm_v(l)%albedo(:,m) =                           &
+                                          albedo_pars_f%pars_xy(1,j+joff,i+ioff)
+                      IF ( albedo_pars_f%pars_xy(1,j+joff,i+ioff) /=           &
+                           albedo_pars_f%fill )                                &
+                         surf_lsm_v(l)%aldir(m) =                              &
+                                          albedo_pars_f%pars_xy(1,j+joff,i+ioff)
+                      IF ( albedo_pars_f%pars_xy(2,j+joff,i+ioff) /=           &
+                           albedo_pars_f%fill )                                &
+                         surf_lsm_v(l)%aldif(m) =                              &
+                                          albedo_pars_f%pars_xy(2,j+joff,i+ioff)
+                      IF ( albedo_pars_f%pars_xy(3,j+joff,i+ioff) /=           &
+                           albedo_pars_f%fill )                                &
+                         surf_lsm_v(l)%asdir(m) =                              &
+                                          albedo_pars_f%pars_xy(3,j+joff,i+ioff)
+                      IF ( albedo_pars_f%pars_xy(4,j+joff,i+ioff) /=           &
+                           albedo_pars_f%fill )                                &
+                         surf_lsm_v(l)%asdif(m) =                              &
+                                          albedo_pars_f%pars_xy(4,j+joff,i+ioff)
+                   ENDIF
+                ENDDO
+
+                ioff = surf_usm_v(l)%ioff
+                joff = surf_usm_v(l)%joff
+                DO  m = 1, surf_usm_v(l)%ns
+                   i = surf_usm_v(l)%i(m)
+                   j = surf_usm_v(l)%j(m)
+
+!--                At the moment, consider only wall surfaces (index 0)
+                   IF ( surf_usm_v(l)%albedo_type(0,m) == 0 )  THEN
+                      IF ( albedo_pars_f%pars_xy(1,j+joff,i+ioff) /=           &
+                           albedo_pars_f%fill )                                &
+                         surf_usm_v(l)%albedo(:,m) =                           &
+                                          albedo_pars_f%pars_xy(1,j+joff,i+ioff)
+                      IF ( albedo_pars_f%pars_xy(1,j+joff,i+ioff) /=           &
+                           albedo_pars_f%fill )                                &
+                         surf_usm_v(l)%aldir(m) =                              &
+                                          albedo_pars_f%pars_xy(1,j+joff,i+ioff)
+                      IF ( albedo_pars_f%pars_xy(2,j+joff,i+ioff) /=           &
+                           albedo_pars_f%fill )                                &
+                         surf_usm_v(l)%aldif(m) =                              &
+                                          albedo_pars_f%pars_xy(2,j+joff,i+ioff)
+                      IF ( albedo_pars_f%pars_xy(3,j+joff,i+ioff) /=           &
+                           albedo_pars_f%fill )                                &
+                         surf_usm_v(l)%asdir(m) =                              &
+                                          albedo_pars_f%pars_xy(3,j+joff,i+ioff)
+                      IF ( albedo_pars_f%pars_xy(4,j+joff,i+ioff) /=           &
+                           albedo_pars_f%fill )                                &
+                         surf_usm_v(l)%asdif(m) =                              &
+                                          albedo_pars_f%pars_xy(4,j+joff,i+ioff)
+                   ENDIF
+                ENDDO
+             ENDDO
+
           ENDIF
 
-          aldif(:,:) = albedo_lw_dif
-          aldir(:,:) = albedo_lw_dir
-          asdif(:,:) = albedo_sw_dif
-          asdir(:,:) = albedo_sw_dir
 !
 !--       Calculate initial values of current (cosine of) the zenith angle and 
@@ -1066,18 +2060,64 @@
           CALL calc_zenith     
 !
-!--       Calculate initial surface albedo
+!--       Calculate initial surface albedo for different surfaces
           IF ( .NOT. constant_albedo )  THEN
-             CALL calc_albedo
+!
+!--          Horizontally aligned default, natural and urban surfaces
+             CALL calc_albedo( surf_def_h(0) )
+             CALL calc_albedo( surf_lsm_h    )
+             CALL calc_albedo( surf_usm_h    )
+!
+!--          Vertically aligned default, natural and urban surfaces
+             DO  l = 0, 3
+                CALL calc_albedo( surf_def_v(l) )
+                CALL calc_albedo( surf_lsm_v(l) )
+                CALL calc_albedo( surf_usm_v(l) )
+             ENDDO
           ELSE
-             rrtm_aldif(0,:,:) = aldif(:,:)
-             rrtm_aldir(0,:,:) = aldir(:,:)
-             rrtm_asdif(0,:,:) = asdif(:,:) 
-             rrtm_asdir(0,:,:) = asdir(:,:)   
+!
+!--          Initialize sun-inclination independent spectral albedos
+!--          Horizontal surfaces
+             IF ( surf_def_h(0)%ns > 0 )  THEN
+                surf_def_h(0)%rrtm_aldir = surf_def_h(0)%aldir
+                surf_def_h(0)%rrtm_asdir = surf_def_h(0)%asdir
+                surf_def_h(0)%rrtm_aldif = surf_def_h(0)%aldif
+                surf_def_h(0)%rrtm_asdif = surf_def_h(0)%asdif
+             ENDIF
+             IF ( surf_lsm_h%ns > 0 )  THEN
+                surf_lsm_h%rrtm_aldir = surf_lsm_h%aldir
+                surf_lsm_h%rrtm_asdir = surf_lsm_h%asdir
+                surf_lsm_h%rrtm_aldif = surf_lsm_h%aldif
+                surf_lsm_h%rrtm_asdif = surf_lsm_h%asdif
+             ENDIF
+             IF ( surf_usm_h%ns > 0 )  THEN
+                surf_usm_h%rrtm_aldir = surf_usm_h%aldir
+                surf_usm_h%rrtm_asdir = surf_usm_h%asdir
+                surf_usm_h%rrtm_aldif = surf_usm_h%aldif
+                surf_usm_h%rrtm_asdif = surf_usm_h%asdif
+             ENDIF
+!
+!--          Vertical surfaces
+             DO  l = 0, 3
+                IF ( surf_def_h(0)%ns > 0 )  THEN
+                   surf_def_v(l)%rrtm_aldir = surf_def_v(l)%aldir
+                   surf_def_v(l)%rrtm_asdir = surf_def_v(l)%asdir
+                   surf_def_v(l)%rrtm_aldif = surf_def_v(l)%aldif
+                   surf_def_v(l)%rrtm_asdif = surf_def_v(l)%asdif
+                ENDIF
+                IF ( surf_lsm_v(l)%ns > 0 )  THEN
+                   surf_lsm_v(l)%rrtm_aldir = surf_lsm_v(l)%aldir
+                   surf_lsm_v(l)%rrtm_asdir = surf_lsm_v(l)%asdir
+                   surf_lsm_v(l)%rrtm_aldif = surf_lsm_v(l)%aldif
+                   surf_lsm_v(l)%rrtm_asdif = surf_lsm_v(l)%asdif
+                ENDIF
+                IF ( surf_usm_v(l)%ns > 0 )  THEN
+                   surf_usm_v(l)%rrtm_aldir = surf_usm_v(l)%aldir
+                   surf_usm_v(l)%rrtm_asdir = surf_usm_v(l)%asdir
+                   surf_usm_v(l)%rrtm_aldif = surf_usm_v(l)%aldif
+                   surf_usm_v(l)%rrtm_asdif = surf_usm_v(l)%asdif
+                ENDIF
+             ENDDO
+
           ENDIF
-
-!
-!--       Allocate surface emissivity
-          ALLOCATE ( rrtm_emis(0:0,1:nbndlw+1) )
-          rrtm_emis = emissivity
 
 !
@@ -1170,6 +2210,11 @@
 
 !
-!--       Allocate dummy array for storing surface temperature
+!--       Allocate 1-element array for surface temperature 
+!--       (RRTMG anticipates an array as passed argument).
           ALLOCATE ( rrtm_tsfc(1) )
+!
+!--       Allocate surface emissivity. 
+!--       Values will be given directly before calling rrtm_lw.
+          ALLOCATE ( rrtm_emis(0:0,1:nbndlw+1) )
 
 !
@@ -1234,8 +2279,14 @@
        IMPLICIT NONE
 
-       INTEGER(iwp) :: i, j, k   !< loop indices
-       REAL(wp)     :: exn,   &  !< Exner functions at surface
-                       exn1,  &  !< Exner functions at first grid level
-                       pt1       !< potential temperature at first grid level
+       INTEGER(iwp) ::  l         !< running index for surface orientation
+
+       REAL(wp)     ::  exn       !< Exner functions at surface
+       REAL(wp)     ::  exn1      !< Exner functions at first grid level or at urban layer top 
+       REAL(wp)     ::  pt1       !< potential temperature at first grid level or mean value at urban layer top 
+       REAL(wp)     ::  pt1_l     !< potential temperature at first grid level or mean value at urban layer top at local subdomain 
+       REAL(wp)     ::  ql1       !< liquid water mixing ratio at first grid level or mean value at urban layer top 
+       REAL(wp)     ::  ql1_l     !< liquid water mixing ratio at first grid level or mean value at urban layer top at local subdomain 
+
+       TYPE(surf_type), POINTER ::  surf !< pointer on respective surface type, used to generalize routine   
 
 !
